#ifndef _ROOTWIDGET_H_
#define _ROOTWIDGET_H_

#include <BaseExternWidget.hxx>

class QLineEdit;
class QTextView;
class QPushButton;
class TCanvas;

// show the usage of properties

class QRootCanvas : public QWidget
{
   Q_OBJECT

public:
   QRootCanvas( QWidget *parent = 0);
   TCanvas* getCanvas() { return fCanvas;}
   int getRootWid() { return wid;}
   void paintHisto();
   void openGLViewer();

 public slots:
   void processRootEvents();

 protected:
   TCanvas     *fCanvas;
   int          wid;

   virtual void closeEvent( QCloseEvent * );
   virtual void mousePressEvent( QMouseEvent *e );
   virtual void mouseReleaseEvent( QMouseEvent *e );
   virtual void resizeEvent( QResizeEvent *e );
   virtual void paintEvent( QPaintEvent *e );
   virtual void mouseMoveEvent(QMouseEvent *e);
};


class MyWidget : public QWidget
{
   Q_OBJECT
   Q_PROPERTY( QStringList values READ getValues WRITE setValues DESIGNABLE true )

   Q_PROPERTY( int intVal READ getIntVal WRITE setIntVal DESIGNABLE true )

  public:
   MyWidget(QWidget *parent);

   QStringList getValues() const { return values; }
   void setValues(const QStringList &list) { values = list; }

   int  getIntVal() const { return intVal; }
   void setIntVal(const int val) { intVal = val; printf("Value set! %i\n",val); }

 protected:

 private:
   QStringList  values;
   int          intVal;
};

// this is the interface class

class EWO_EXPORT RootWidget : public BaseExternWidget
{
  Q_OBJECT

  public:
    RootWidget(QWidget *parent);

    virtual QWidget *widget() const;
    virtual QStringList signalList() const;

  public slots:
    void clicked1();
    void clicked2();
    void onCommandLine();

  private:
    MyWidget    *baseWidget;
    QRootCanvas *canvas;
    QPushButton *b;
    QPushButton *v;
    QLineEdit   *le;
    QTextView   *tv;
};

#endif
